% Program "odeljci"

clc; close all; clear; tic 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% PROMENLJIVE %%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

broj_cestica=XXX;
broj_odeljaka=XXX;
broj_ciklusa=XXX;         % Broj rasporedjivanja odredjenog broja cestica po odeljcima

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

raspodela=zeros(broj_odeljaka,broj_cestica+1);
broj_u_odeljcima=zeros(1,broj_odeljaka);

for i=1:broj_ciklusa
 for j=1:broj_cestica
   indeks=floor(rand*(broj_odeljaka))+1;
   broj_u_odeljcima(indeks)=broj_u_odeljcima(indeks)+1;
 end
 for k=1:broj_odeljaka
  raspodela(k,broj_u_odeljcima(k)+1)=raspodela(k,broj_u_odeljcima(k)+1)+1;
 end
 broj_u_odeljcima=zeros(1,broj_odeljaka);
end

x0=0:broj_cestica;
raspodela=raspodela./broj_ciklusa;

N=broj_cestica;
p=1/broj_odeljaka;

x1=0:N;
binomna_raspodela=binopdf(x1,N,p);

mu = N*p;
sigma = sqrt(N*p*(1-p));
x2 = 0:0.1:N;
normalna_raspodela = normpdf(x2,mu,sigma);

x3=0:N;
mu_2 = N*p;
poasonova_raspodela = poisspdf(x3,mu_2);

feature('DefaultCharacterSet', 'ISO-8859-1');

figure
plot(x0,sum(raspodela)/broj_odeljaka,'ok-',x1,binomna_raspodela,'r-',x2,normalna_raspodela,'b-',x3,poasonova_raspodela,'g-',...
    'LineWidth',1.5,...
    'MarkerSize',5,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','k')
xlabel('\bf \fontsize{15} \fontname{Cambria} Broj cestica');
ylabel('\bf \fontsize{15} \fontname{Cambria} Verovatnoca');
legend ('\fontname{Cambria} Raspodela cestica','\fontname{Cambria} Binomna raspodela','\fontname{Cambria} Gausova raspodela','\fontname{Cambria} Poasonova raspodela')

fprintf('\n')
fprintf('-----------------------------------------------------\n')
fprintf('\n')

toc